;   

#define Src		7
#define	Dist	6
#define	_ISrc	M_Parm,Src
#define	_IDist	M_Parm,Dist


;======================================================
;   C-AkkA  C-AkkB
; C_AkkA=C_AkkA+C_AkkB
;======================================================
Add_C
		movlw	LOW AkkARe	;   .  "A"
		call	CCopy4_To_A
		movlw	LOW AkkBRe	;   .  "B"
		call	CCopy4_To_B
		call	FPA32		; A=A+B
		movlw	LOW AkkARe		
		call	CCopy4_From_A	;  

		movlw	LOW AkkAIm	; .  .  "A"
		call	CCopy4_To_A
		movlw	LOW AkkBIm	; .  .  "B"
		call	CCopy4_To_B
		call	FPA32		; A=A+B
		movlw	LOW AkkAIm		
		call	CCopy4_From_A	;  
		return

;======================================================
;   C-AkkA  C-AkkB
; C_AkkA=C_AkkA-C_AkkB
;======================================================
Sub_C
		movlw	LOW AkkARe	;   .  "A"
		call	CCopy4_To_A
		movlw	LOW AkkBRe	;   .  "B"
		call	CCopy4_To_B
		call	FPS32		; A=A-B
		movlw	LOW AkkARe		
		call	CCopy4_From_A	;  

		movlw	LOW AkkAIm	; .  .  "A"
		call	CCopy4_To_A
		movlw	LOW AkkBIm	; .  .  "B"
		call	CCopy4_To_B
		call	FPS32		; A=A-B
		movlw	LOW AkkAIm		
		call	CCopy4_From_A	;  
		return

;======================================================
;   AkkA = AkkA * AkkB
;
; (AkkARe + j*AkkAIm) * (AkkBRe + j*AkkBIm) =
;
; = (AkkARe * AkkBRe - AkkAIm * AkkBIm) + j(AkkAIm * AkkBRe + AkkARe * AkkBIm)
;======================================================
Mpl_C
		movlw	LOW AkkAIm	; .  .  "A"
		call	CCopy4_To_A
		movlw	LOW AkkBIm	; .  .  "B"
		call	CCopy4_To_B
		call	FPM32		; A=A*B
		movlw	LOW TempRe	;  
		call	CCopy4_From_A

		movlw	LOW AkkARe	;   .  "A"	
		call	CCopy4_To_A
		movlw	LOW AkkBRe	;   .  "B"
		call	CCopy4_To_B
		call	FPM32		; A=A*B

		movlw	LOW TempRe		
		call	CCopy4_To_B
		call	FPS32		; A=A-B (A=Real part)
		movlw	LOW TempRe
		call	CCopy4_From_A	;  

		movlw	LOW TempIm
		call	CCopy4_From_A

; .   
		movlw	LOW AkkAIm	; .  .  "A"	
		call	CCopy4_To_A
		movlw	LOW AkkBRe	;   .  "B"
		call	CCopy4_To_B
		call	FPM32		; A=A*B
		movlw	LOW TempIm
		call	CCopy4_From_A

		movlw	LOW AkkARe	;   .  "A"
		call	CCopy4_To_A
		movlw	LOW AkkBIm	; .  .  "B"
		call	CCopy4_To_B
		call	FPM32		; A=A*B
		movlw	LOW TempIm		
		call	CCopy4_To_B
		call	FPA32		; A=A+B (A=Imag part)
		movlw	LOW AkkAIm		
		call	CCopy4_From_A	;   . 

		movlw	LOW TempRe
		call	CCopy4_To_A	;    
		movlw	LOW AkkARe		
		call	CCopy4_From_A	;    
		return
		
;=======================================================================
;     A=A/B
;
;  AkkARe + j*AkkAIm     AkkARe*AkkBRe + AkkAIm*AkkBIm        AkkBRe*AkkAIm - AkkARe*AkkBIm
;  ------------------ = -------------------------------- + j*------------------------------
;  AkkBRe + j*AkkBIm     AkkBRe*AkkBRe + AkkBIm*AkkBIm        AkkBRe*AkkBRe + AkkBIm*AkkBIm
;
;=======================================================================
Div_C
		;  
		movlw	LOW AkkBRe
		call	CCopy4_To_A	; AkkBRe -> A
		call	BEQUA		; A -> B
		call	FPM32		; A=A*B, .. =AkkBRe*AkkBRe
		movlw	LOW TempC
		call	CCopy4_From_A	; Y=AkkBRe*AkkBRe
		movlw	LOW AkkBIm
		call	CCopy4_To_A	; AkkBIm -> A
		call	BEQUA		; A -> B
		call	FPM32		; A=A*B, .. =AkkBIm*AkkBIm
		movlw	LOW TempC
		call	CCopy4_To_B
		call	FPA32		; A=AkkBRe*AkkBRe + AkkBIm*AkkBIm ()
		movlw	LOW TempC
		call	CCopy4_From_A	;  

		;   
		movlw	LOW AkkARe
		call	CCopy4_To_A	; AkkARe -> A
		movlw	LOW AkkBRe
		call	CCopy4_To_B	; AkkBRe -> B
		call	FPM32		; A = AkkARe * AkkBRe
		movlw	LOW TempRe
		call	CCopy4_From_A
		movlw	LOW AkkAIm
		call	CCopy4_To_A	; AkkAIm -> A
		movlw	LOW AkkBIm
		call	CCopy4_To_B	; AkkBIm -> B
		call	FPM32		; A = AkkAIm * AkkBIm
		movlw	LOW TempRe
		call	CCopy4_To_B
		call	FPA32		; A = AkkARe*AkkBRe + AkkAIm*AkkBIm
		movlw	LOW TempC
		call	CCopy4_To_B	; B = 
		call	FPD32		; A = A / B
		movlw	LOW TempRe
		call	CCopy4_From_A	;   

		;  
		movlw	LOW AkkARe
		call	CCopy4_To_A	; AkkARe -> A
		movlw	LOW AkkBIm
		call	CCopy4_To_B	; AkkBIm -> B
		call	FPM32		; A = AkkARe * AkkBIm
		movlw	LOW TempIm
		call	CCopy4_From_A
		movlw	LOW AkkBRe
		call	CCopy4_To_A	; AkkBRe -> A
		movlw	LOW AkkAIm
		call	CCopy4_To_B	; AkkAIm -> B
		call	FPM32		; A = AkkBRe * AkkAIm
		movlw	LOW TempIm
		call	CCopy4_To_B
		call	FPS32		; A = AkkBRe * AkkAIm - AkkARe * AkkBIm
		movlw	LOW TempC
		call	CCopy4_To_B	; B = 
		call	FPD32		; A = A / B
		movlw	LOW AkkAIm
		call	CCopy4_From_A	;   

		movlw	LOW TempRe
		call	CCopy4_To_A	;   
		movlw	LOW AkkARe
		call	CCopy4_From_A	;   
		return

;=======================================================================
;    Zsm  
;       
; : WREG
;=======================================================================
Get_Zsm 
		;     64  (2**6)
		pagesel Freq_mult_8
		call	Freq_mult_8 	;*8 ->   Temp1
		rlf	Temp1, F	;*16
		rlf	Temp1, F	;*32
		rlf	Temp1, F	;*64

		movf	Range, W
		movwf	Temp2
		bcf	STATUS, C
		rlf	Temp2, F	;*2
		rlf	Temp2, F	;*4
		rlf	Temp2, F	;*8

		movlw	LOW Zsm_begin
		addwf	Temp1, W
		addwf	Temp2, W
		pagesel	$
		return

;=======================================================================
;    EEPROM Zs  
;    
; : WREG
;=======================================================================
Get_Zs
		pagesel 	Freq_mult_8
		call		Freq_mult_8 	;   Temp1
		movlw		LOW Zs
		addwf		Temp1, W
		pagesel		$
		return
;=======================================================================
;    EEPROM Zo  
;    
; : WREG
;=======================================================================
Get_Zo
		pagesel 	Freq_mult_8
		call		Freq_mult_8 	;   Temp1
		movlw		LOW Zo
		addwf		Temp1, W
		pagesel		$
		return
;=======================================================================
;    EEPROM Zstd  
;    
; : WREG
;=======================================================================
;Get_Zstd
;		movf	Range, W
;		movwf	Temp1
;		bcf		STATUS, C
;		rlf		Temp1, F	;*2
;		rlf		Temp1, F	;*4
;		rlf		Temp1, F	;*8
;		movlw	LOW Zsdt_0
;		addwf	Temp1, W
;		return

;=======================================================================
;	   EEPROM    
;  WREG ->   EEPROM
;=======================================================================
CEE_To_A
		banksel	EE_ADR
		movwf	EE_ADR		;    EEPROM
		movlw	LOW AkkARe
		goto	EE_Read
;=======================================================================
;	   EEPROM    B
;  WREG ->   EEPROM
;=======================================================================

CEE_To_B
		banksel	EE_ADR
		movwf	EE_ADR		;    EEPROM
		movlw	LOW AkkBRe
EE_Read
		addlw	.3		;     
		movwf	FSR
		movlw	.2
		movwf	Count1
		bankisel AkkARe
EE_Imag
		movlw	.4		;  
		movwf	Count2

EE_Cmpl_Loop
		call	ReadEEPROM
		movwf	INDF
		banksel	EE_ADR		;  
		incf	EE_ADR, F
		decf	FSR, F
		decfsz	Count2, F
		goto	EE_Cmpl_Loop
		decfsz	Count1, F
		goto	ReadImag
		bankisel	0
		return
ReadImag
		movlw	.8
		addwf	FSR, F
		goto	EE_Imag	


;=======================================================================
;   (8 )         B
;  WREG ->    
;=======================================================================
Zstd_To_A
		movwf		f_tmp		;     
		movlw		LOW AkkARe+.3
		goto		Zstd_read

Zstd_To_B
		movwf		f_tmp		;     
		movlw		LOW AkkBRe+.3
Zstd_read
		call		pre_read
Z_std_loop
		movlw 		HIGH Zstd_table
		movwf		PCLATH
		movf		f_tmp, W
		call		Zstd_table	; 
		pagesel	$
		call		save_and_inc
		decfsz		Count1, F	; ?	
		goto		Z_std_loop	; ,    
		bankisel	0
		return


;-----------------------------------------------------------------------
Zsm_To_A
		movwf		f_tmp		;     
		movlw		LOW AkkARe+.3
		goto		Zsm_read
;-----------------------
Zsm_To_B
		movwf		f_tmp		;     
		movlw		LOW AkkBRe+.3
Zsm_read
		call		pre_read
Z_sm_loop
		movlw 		HIGH Zsm_table
		movwf		PCLATH
		movf		f_tmp, W
		call		Zsm_table	; 
		pagesel	$
		call		save_and_inc
		decfsz		Count1, F	; ?	
		goto		Z_sm_loop	; ,    
		bankisel	0
		return

;---------------
pre_read
		bankisel	AkkBRe
		movwf		FSR
		decf		f_tmp, F	;     
		movlw		8		; 
		movwf		Count1
		return
;---------------
save_and_inc
		movwf		INDF		;
		incf		f_tmp, F;
		decf		FSR, F
		movf		Count1, W
		sublw		.5
		movlw		.8
		btfsc		STATUS, Z	;   Re?
		addwf		FSR, F		;   Im
		return

;=======================================================================
;   A (8 )    
;        W
;        EEADRH ( 2)
;
;    PIC16F876A     4 ,
;    00
;=======================================================================
CPRG_From_A
		banksel		EEADR		;2
		movwf		EEADR
		;     
;		movlw		HIGH Zsm_begin
;		movwf		EEADRH	;   
		movlw		0x34	;    (  RETLW k)
		movwf		EEDATH
		banksel		Count1
		movlw		.8	;     (   4)
		movwf		Count1
		bankisel	AkkARe
		movlw		LOW AkkARe + 3	;  
		movwf		FSR
flash_write_loop
		movf		INDF,W
		banksel		EEDATA		;2
		movwf		EEDATA		;  
		decf		FSR, F		;    

		banksel		EECON1		; 3
		bsf			EECON1, EEPGD	; FLASH  
		bsf			EECON1, WREN	;   FLASH  
		bcf			INTCON, GIE		; 
		movlw		0x55
		movwf		EECON2		; 55h   EECON2
		movlw		0xAA
		movwf		EECON2		; AAh   EECON2
		bsf			EECON1, WR	; 
		nop
		nop

		bcf			EECON1, WREN	;   FLASH  
		bsf			INTCON, GIE	; 
		banksel		EEADR
		incf		EEADR, F
		banksel		Count1
		movf		Count1, W
		sublw		.5
		movlw		.8
		btfsc		STATUS, Z	;   Re?
		addwf		FSR, F		;   Im
		decfsz		Count1, F	; ?	
		goto		flash_write_loop	; ,    
		banksel		0
		bankisel	0
		return


;=======================================================================
;     : : WREG =   
; Temp1 =   -    
; Temp2 =   -    
; M_Parm -    ->     
;	-  4-  ->  
;=======================================================================

;=======================================================================
;    (8 )     (2- )
;      WREG (0- )
;=======================================================================
CLoad_From_A
		banksel		Temp1
		movwf		Temp1		;   
		movlw		LOW AkkARe	;   . 
		movwf		Temp2		;   
		movlw		(1<<Src)|0x08	;   2-o ,   8 
		goto		MoveBlock

;=======================================================================
;    (8 )    WREG (0- )
;     (2- )
;=======================================================================
CLoad_To_A
		banksel		Temp2
		movwf		Temp2		;   
		movlw		LOW AkkARe	;   . 
		goto		MoveBlock4

;=======================================================================
;    (8 )  AkkB    (0- )
;    B (2- )
;=======================================================================
CLoad_To_B
		banksel		Temp2		
		movwf		Temp2		;   
		movlw		LOW AkkBRe	;   . B
MoveBlock4
		movwf		Temp1		;   
		movlw		(1<<Dist)|0x08	;   2-o ,   8 
		goto		MoveBlock

;=======================================================================
;    (8 )    WREG (2- )
;    A (2- )
;=======================================================================
CCopy8_To_A 	;CLoadB_From
		banksel		Temp2
		movwf		Temp2		;   
		movlw		LOW AkkARe	;   ". B" 
		movwf		Temp1		;   
		goto		MoveBlock3
		
;=======================================================================
;    (8 )    WREG (2- )
;    B (2- )
;=======================================================================
CCopy8_To_B 	;CLoadB_From
		banksel		Temp2
		movwf		Temp2		;   
		movlw		LOW AkkBRe	;   ". B" 
		movwf		Temp1		;   
		goto		MoveBlock3

;=======================================================================
;        (2- )
;   (8 )    WREG (2- )
;=======================================================================
CCopy8_From_A	;CSaveA_To
		banksel		Temp1
		movwf		Temp1		;   	
		movlw		LOW AkkARe	;   ". " 
		movwf		Temp2		;   
MoveBlock3
		;     2- ,   8 
		movlw		(1<<Dist)|(1<<Src)|0x08
		goto		MoveBlock

;=======================================================================
;    (4 )  "Float AkkA" (0- )
;      WREG (2- )
;=======================================================================
CCopy4_From_A
		banksel		Temp1
		movwf		Temp1		;   
		movlw		AARGB2		;   "float A" 
		movwf		Temp2		;   
		movlw		(1<<Dist)|0x04	;   2-o ,   4- 
		goto		MoveBlock
;=======================================================================
;    (4 )    WREG (2- )
;  "Float AkkB" (0- )
;=======================================================================
CCopy4_To_B
		banksel		Temp2
		movwf		Temp2		;   
		movlw		BARGB2		;   "float akk. B"
		goto		MoveBlock1
;=======================================================================
;    (4 )    WREG (2- )
;  "Float AkkA" (0- )
;=======================================================================
CCopy4_To_A
		banksel		Temp2		
		movwf		Temp2		;   
		movlw		AARGB2		;   "float akk. "
MoveBlock1
		movwf		Temp1		;   
		movlw		(1<<Src)|0x04	;   3- ,   4- 
MoveBlock
		movwf		M_Parm		;      
		movlw		0x0F		
		andwf		M_Parm, W	;  
		movwf		Count1		;  a   
CopyLoop
		movf		Temp2, W	;  
		movwf		FSR
		bankisel	AARGB2		;   / 
		btfsc		_ISrc
		bankisel	AkkARe		;   / 
		movf		INDF, W		;    
		movwf		Temp3		;  
		movf		Temp1, W	;  
		movwf		FSR
		movf		Temp3, W	;  .  
		bankisel	AARGB2		;   / 
		btfsc		_IDist		; 1  3 ?
		bankisel	AkkARe		;   / 
		movwf		INDF		;     
		incf		Temp1, F 	;    
		incf		Temp2, F 	; 
		decfsz		Count1, F	; ?	
		goto		CopyLoop	; ,    
		bankisel	0
		return

;======================================================
;  Open/Short/Load 
;       Zstd * (Zo - Zsm) * (Zxm - Zs) 
; Zx =  ------------------------------
;        (Zsm - Zs) * (Zo - Zxm)
; 	Zstd 	-   
;	Zsm	-   
;	Zo	-  "Open"
;	Zs	-  "Short"
;	Zxm	-   DUT
; : Zx
;     !
;======================================================
OSL_Cor
;***********************************************************************************
;  
		btfsc	Flags3, OSL_Off
		goto	no_OSL

		call	Get_Zsm		;      RLC-2 
		call	Zsm_To_A	;    .  A

		call	Get_Zs		;  EEPROM  Zs   
		call	CEE_To_B	;    .  B

		call	Sub_C		; A=A-B -> ( Zsm - Zs )   

		movlw	LOW C2Re
		call	CCopy8_From_A	;    C2   
;---------------------------------------------------------------
		call	Get_Zo		;  EEPROM  Zo   
		call	CEE_To_A	;    .  

		movlw	Z_Re3		;     Dut
		call	CLoad_To_B	;  Zxm

		call	Sub_C		; A=A-B -> ( Zo - Zxm )   

		movlw	LOW C2Re
		call	CCopy8_To_B	; B = ( Zsm - Zs )

		call	Mpl_C		; A=A*B -> ( Zsm - Zs )*( Zo - Zxm )

		movlw	LOW C2Re
		call	CCopy8_From_A	;    C2   

;***********************************************************************************
;  
		call	Get_Zo		;  EEPROM  Zo   
		call	CEE_To_A	;    .  

		call	Get_Zsm		;      RLC-2 
		call	Zsm_To_B	;    .  B
			
		call	Sub_C		; A=A-B -> ( Zo - Zsm )   

		movlw	LOW C1Re
		call	CCopy8_From_A	;    C1   
;---------------------------------------------------------------
		movlw	Z_Re3		;     Dut
		call	CLoad_To_A	;  Zxm

		call	Get_Zs		;  EEPROM  Zs   
		call	CEE_To_B	;    .  B

		call	Sub_C		; A=A-B -> ( Zxm - Zs )   

		movlw	LOW C1Re
		call	CCopy8_To_B	; B = ( Zo - Zsm )

		call	Mpl_C		; A=A*B -> ( Zxm - Zs )*( Zo - Zsm )
;***********************************************************************************
		movlw		LOW C2Re	; 
		call		CCopy8_To_B	; B = ( Zsm - Zs )*( Zo - Zxm )

;  ,     Zstd -    
		call		Div_C		; A=A/B -> ( Zxm - Zs )*( Zo - Zsm )/( Zsm - Zs )*( Zo - Zxm )

; 
		call	Get_Zsm	;    Zstd  Zsm 
		call	Zstd_To_B	;    .  B
		call	Mpl_C		; A=A*B -> Zstd*( Zxm - Zs )*( Zo - Zsm )/( Zsm - Zs )*( Zo - Zxm )

no_OSL		
		call		Auto_LC	;   

		btfss		Flags1, S_P	;0-  , 1-
		goto		to_Z
;      Y=1/Z
		movlw		LOW AkkBRe
		call		CCopy8_From_A	;  Z   B
		movlw		LOW	E0	;1
		call		Prog_To_A
		movlw		LOW AkkARe
		call		CCopy4_From_A
		call		ClrA
		movlw		LOW AkkAIm
		call		CCopy4_From_A
		call		Div_C	;Y=1/Z

to_Z
		movlw		Z_Re3		;     Dut
		call		CLoad_From_A
		return

;=======================================================================
;     ,  Z
;     Z= U/I
;=======================================================================
Div_UI
		movlw		U_Re3		;     Dut
		call		CLoad_To_A	;  Zxm
		movlw		I_Re3		;     Dut
		call		CLoad_To_B	;  Zxm
		call		Div_C
		movlw		Z_Re3		;     Dut
		call		CLoad_From_A
		return


;=======================================================================
;    L  C  
;  :
;	Z   . 
;
; - --------------------max_C--- - 0 + ------------------------max_L----  +
;   CCCCCCCCCCCCCCCCCCCCCC -L -L -L  L LLLLLLLLLLLLLLLLLLLLLLLLLL -C -C -C
;   ..    max_C < X < max_L   
;=======================================================================
Auto_LC
		; 
		btfss		Flags3, fixed_C
		goto		LC_1
		bsf			db_flags, L_C	; 0-L, 1-C
		return
LC_1		
		btfss		Flags3, fixed_L
		goto		LC_2
		bcf			db_flags, L_C	; 0-L, 1-C
		return

; 
LC_2
		bsf			db_flags, L_C	; 0-L, 1-C		
		movlw		LOW AkkAIm	; X ( )
		call		CCopy4_To_A
		
		movlw		LOW max_C	; X   
		call		Prog_To_B
		
		call		TAGTB32	; if A > B TRUE  W = 0x01, else W=0
		iorlw		0	;   
		btfsc		STATUS, Z
		return
		movlw		LOW max_L	; X   
		call		Prog_To_B
		call		TALTB32	; if A < B TRUE  W = 0x01, else W=0
		iorlw		0	;   
		btfsc		STATUS, Z
		return
		bcf			db_flags, L_C	; 0-L, 1-C
		return

