;X* -    ,   
#define CPos		X0
;******************************************************************************************************
;---    ---
; :
;	S1 -  
;	S2 -  ()
;	S3 -  ()
;	S4 -  
;	S5 -  
;	S6 -     
;  0...7   
;     0...7
;-  8 -    
;******************************************************************************************************

Ubias_edit
		movlw		LOW Coeff_Ubias
		movwf		X1	;    EEPROM Xstd_0
		goto		edit_2

Xstd_edit
		movlw		LOW Zsdt_0 + 4
		movwf		X1	;    EEPROM Xstd_0
		goto		edit_1

Rstd_edit
		movlw		LOW Zsdt_0
		movwf		X1	;    EEPROM Rstd_0

edit_1
		;          (Range)
		call		GetADR
edit_2		
		pagesel		EEPROM_To_B
		call		EEPROM_To_B		; Get value for parameters into block B
		movf		BEXP, W	;    - 
		movwf		X2		;    X2.  - U_bias   0.
		clrf		CPos			;  
		pagesel		CmdLCD
		call		Save_set	;    , .. Freg   
		call		CurOn			;    
		call		ClrDSP
		call		SecLine		;   
		pagesel		$
		banksel		Mpos
		movlw		LOW (Help_Key-Table4)
		call		PrintStr	;   
		banksel		0
		
		call		Disp_C_num
		call		Disp_C


;************************************
;-----           -----
;************************************
Kn_edit
		movlw		Kn_ALL_UP
		subwf		Btn_status, W
		btfsc		STATUS, Z
		goto		Kn_edit_end		;   

		btfss		_Long_Btn1		;   ""  
		goto		Kn_Long_Chk
;*****************************************
;-----    -----
;*****************************************
		bcf			_Long_Btn1		;   "" 
		goto		Kn_edit_end

Kn_Long_Chk
		btfss		Flags, long_btn
		goto		Kn_edit_1
		bcf			Flags, long_btn
;*************************************
;-----    -----
;*************************************
		btfsc		Btn_status, Btn_S6	;S6 -    L/C
		goto		Kn_edit_end
		btfss		X2, Xstd_C
		goto		tst_Xstd_L
		movlw		0x86	;
		goto		set_Xstd
tst_Xstd_L		
		btfss		X2, Xstd_L
		goto		Kn_edit_end		
		movlw		0x48	;
set_Xstd
		movwf		X2
		call		Disp_C_num
		call		Disp_C
		bsf			Flags2, C_change		
		goto		Kn_edit_end

;*************************************
;-----    -----
;*************************************
Kn_edit_1
		btfsc		Btn_status, Btn_S1	;
		goto		Kn_edit_2
		btfsc		Flags2, C_change
		call		Save_C
Kn_1_exit		
		pagesel		CmdLCD
		call		CurOff	; 
		call		Restore_set
		;goto		Kn_end
		pagesel		Menu1Loop
		goto		Menu1Loop		;    1- 

;------
Kn_edit_2
		btfsc		Btn_status, Btn_S2	; 
		goto		Kn_edit_3
		incf		CPos, F
		movlw		.7
		subwf		CPos, W
		btfsc		STATUS, Z
		clrf		CPos
		call		Set_cur
		goto		Kn_edit_end

;------
Kn_edit_3
		btfsc		Btn_status, Btn_S3	; 
		goto		Kn_edit_4
		bsf		Flags2, C_change
		call		Exp_To_A
		call		CompA		; A=-A
		call		Sum24_AB
		btfss		AARGB0, 7	; -   ?
		pagesel		BEQUA
		call		BEQUA		;    
		pagesel		$
		call		Disp_C
		goto		Kn_edit_end

;------
Kn_edit_4
		btfsc		Btn_status, Btn_S4	; 
		goto		Kn_edit_5
		call		Exp_To_A
		call		Sum24_AB
;********** 24 BIT
;if( A <= K ),  =0x98967F=.9999999
		movfw		AARGB0
		sublw		0x98
		skpc
		goto		endif24
		skpz
		goto		then24
		movfw		AARGB1
		sublw		0x96
		skpc
		goto		endif24
		skpz
		goto		then24
		movfw		AARGB2
		sublw		0x7F
		skpc
		goto		endif24
then24
		bsf		Flags2, C_change
		pagesel		BEQUA
		call		BEQUA
		pagesel		$
endif24
		call		Disp_C
		goto		Kn_edit_end

;------
Kn_edit_5
		btfsc		Btn_status, Btn_S5	; 
		goto		Kn_edit_6
		decf		CPos, F
		movlw		0xFF
		subwf		CPos, W
		movlw		.6
		btfsc		STATUS, Z
		movwf		CPos
		call		Set_cur
		goto		Kn_edit_end

;------
Kn_edit_6
		btfsc		Btn_status, Btn_S6	; 
		goto		Kn_edit_end
		btfsc		Flags2, C_change
		call		Save_C
		
		movf		X2, F	; 0 -  -  Ubias
		btfsc		STATUS, Z
		goto		Kn_1_exit
		
		incf		Range, F
		movlw		.8
		subwf		Range, W
		btfsc		STATUS, Z
		clrf		Range
		call		GetADR
		pagesel		EEPROM_To_B
		call		EEPROM_To_B		; Get value for parameters into block B
		movf		BEXP, W	;    - 
		movwf		X2	;  
		pagesel		$
		call		Disp_C_num
		call		Disp_C
		goto		Kn_edit_end

;-----------
Kn_edit_end	
		movlw		Kn_ALL_UP
		movwf		Btn_status
		
		pagesel		Delay_50_ms
		call		Delay_50_ms		;      
		pagesel		$

		goto		Kn_edit
	
;---------------------------------------------
;  -   
;---------------------------------------------
Disp_C
		clrf		AEXP	;  "B"  . ""    BCD-
		clrf		AARGB0
		movf		BARGB2, W
		movwf		AARGB3
		movf		BARGB1, W
		movwf		AARGB2
		movf		BARGB0, W
		movwf		AARGB1

		pagesel		CmdLCD
		movlw		0x80+.6
		call		CmdLCD
		call		BCD
;   
		bcf			Flags, L_Z 	;   
		movlw		8		;    
		movwf		Y2

		swapf		BCD3, F
		movlw		BCD3
		call		DispBCD
		movlw		BCD2
		call		DispBCD
		movlw		BCD2
		call		DispBCD
		call		DispDot		; 
				
		movlw		BCD1
		call		DispBCD
		movlw		BCD1
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		movlw		BCD0
		call		DispBCD
		
		pagesel		$
		movf		X2, F	;  -  Ubias
		btfsc		STATUS, Z
		goto		disp_C_1
		
		pagesel		CharLCD
		decf		X2, W	;     1
		andlw		0x0F
		movwf		Y0
		call		prefix	;   -  Y0
		movlw		1	; 
		btfsc		X2, Xstd_C
		movlw		"F"
		btfsc		X2, Xstd_L
		movlw		"H"
		call		CharLCD
		call		DispSP
		pagesel		$

disp_C_1
		call		Set_cur
		return

;---------------------------------------------
;   -
;---------------------------------------------
Disp_C_num
		pagesel		CmdLCD
		movlw		0x80	;    1- 
		call		CmdLCD
		
		pagesel		$
		movf		X2, F	;  -  Ubias
		btfss		STATUS, Z
		goto		d_1
		pagesel		Read_String
		movlw		LOW _Ubias
		call		Read_String
		pagesel		$
		return

d_1		
		pagesel		Read_String
		movlw		"R"
		btfsc		X2, Xstd_C
		movlw		"C"
		btfsc		X2, Xstd_L
		movlw		"L"
		call		CharLCD
		movlw		LOW _Rstd
		call		Read_String
		movf		Range, W
		call		NumLCD
		call		DispSP
		pagesel		$
		return

;---------------------------------------------
;    
Set_cur
		movlw		4
		subwf		CPos, W
		movf		CPos, W
		btfsc		STATUS, C
		addlw		1	; 4-  ()
		pagesel		CmdLCD
		sublw		0x80+.13		;   
		call		CmdLCD
		pagesel		$
		return
;---------------------------------------------
; -  EEPROM
Save_C
		bcf			Flags2, C_change	;    -
		movf		X2, W
		movwf		BEXP		;        B
		
		movlw		LOW Coeff_Ubias	; -  Ubias  EEPROM
		movf		X2, F	; 0 -  -  Ubias
		btfss		STATUS, Z
		call		GetADR
		pagesel		B_To_EEPROM		
		call		B_To_EEPROM
		pagesel		$

		movf		X2, F	; 0 -  -  Ubias
		btfss		STATUS, Z
		call		Save_Zstd_to_Prog	;  Zstd     

		;   LOAD    
		pagesel 	CharLCD
		movlw		0x80
		call		CmdLCD
		pagesel		$
		banksel		Mpos
		movlw		LOW (Need_Load-Table4)
		call		PrintStr
		banksel		0
		pagesel		Delay_05_sec
		movf		Range, W
		call		NumLCD
		call		Delay_05_sec
		call		Delay_05_sec
		call		Delay_05_sec
		call		Delay_05_sec
		pagesel		$
		
		call		reset_EE_LOAD
		
		return

;---------------------------------------------
Exp_To_A
		clrf		AEXP
		clrf		AARGB0
		movlw 		HIGH Table
		movwf 		PCLATH
		bcf			STATUS, C
		rlf			CPos, W		;   2
		addwf		CPos, W	;   3
		addlw		LOW _exp - 1
		movwf		Temp1		;  
		pagesel		Table
		call		Table		;   
		movwf		AARGB0		
		incf		Temp1, F
		movf		Temp1, W
		call		Table		;   
		movwf		AARGB1
		incf		Temp1, W
		call		Table		;   
		movwf		AARGB2
		pagesel		$
		return

;*****************************************************************************************************
; Get addres parametr to change 
;*****************************************************************************************************
GetADR
		movf		Range, W	; Get current parameter when need to change
		movwf		Temp1
		bcf			STATUS, C
		rlf			Temp1, F	; *2
		rlf			Temp1, F	; *4
		rlf			Temp1, F	; *8 Parameters is 8 butes length
		movf		X1, W
		addwf		Temp1, W	; add adress first parametr
		return

;******************************************************************************************************
; Integer addition
; AkkA=AkkA+AkkB
;******************************************************************************************************
Sum24_AB:
		movfw	BARGB2			; Low byte
		addwf	AARGB2, F	

		movfw 	BARGB1			; Middle byte
		btfsc	STATUS, C
		incfsz	BARGB1, W
		addwf   AARGB1, F

		movfw	BARGB0			; High byte
		btfsc	STATUS, C
		incfsz	BARGB0, W
		addwf	AARGB0, F
		return

;******************************************************************************************************
; Complemnt AkkA
; AkkA=-AkkA
;******************************************************************************************************
CompA:
		banksel	AARGB2
		comf	AARGB2, F	;Complement all bytes
		comf	AARGB1, F
		comf    AARGB0, F

		incf	AARGB2, F	;Inc. low byte always
		skpnz			;Skip if no carry to higher bytes
		incf	AARGB1, F	;Carry to next byte
		skpnz
		incf	AARGB0, F
		return


;====================================================================================
;      Zstd   
; Zstd       
;         .
; Zstd      EEPROM    
;       ,   .
;:	X1 -    EEPROM Xstd_0
;		X2 -       Zstd
;		Range -  
;====================================================================================
Save_Zstd_to_Prog
		call		GetADR ;    Zstd  EEPROM
		movwf		X3	;  
		movlw		1<<Xstd_C | 1<<Xstd_L
		andwf		X2, W	;  6  7   ,  Rstd (. )
		movlw		4
		btfss		STATUS, Z
		subwf		X3, F	;    ,    4 
;---------------
;  
		movf		X3, W
		pagesel		EEPROM_To_A
		call		EEPROM_To_A
		movf		AEXP, W
		movwf		X2	;    
		clrf		AEXP
		call		FLO32	;  float
		movlw		LOW E1	; 10
		call		EEPROM_To_B
		call		FPD32	;A=A/10	
		; 
		movf		X2, W
		call		W_mult_4
		movlw		LOW E9
		addwf		Temp1, W	; +
		call		Prog_To_B
		call		FPM32	; * Rstd
		movlw		LOW C1Re
		call		CCopy4_From_A	; Rstd -> C1Re
;------    G=1/R
		call		BEQUA
		movlw		LOW E0	;  1
		call		Prog_To_A
		call		FPD32	;A=A/B -    G
		movlw		LOW C1Im
		call		CCopy4_From_A	; G=1/Rstd -> C1Im
		
;-----------------
;  
		movlw		4
		addwf		X3, W
		call		EEPROM_To_A
		movf		AEXP, W
		movwf		X2	;    
		clrf		AEXP
		call		FLO32	;  float
		movlw		LOW E1	; 10
		call		EEPROM_To_B
		call		FPD32	;A=A/10
		; 
		movlw		0x0F
		andwf		X2, W	;    
		call		W_mult_4
		movlw		LOW E9
		addwf		Temp1, W	; +
		call		Prog_To_B
		call		FPM32	;A =  * LCstd
		movlw		LOW C2Re
		call		CCopy4_From_A	; LC -> C2Re

;  B_C=Cp*W=Cp/(1/W),  (W=2*Pi*F)
;  X_L=Ls*W=Ls/(1/W)
		clrf		Freq	; = 100 
freq_loop
		pagesel		W_mult_4
		movf		Freq, W
		call		W_mult_4
		movlw		LOW	w100_1	;
		addwf		Temp1, W	; +
		call		Prog_To_B	; 1/W->B
		movlw		LOW C2Re
		call		CCopy4_To_A	; LC  A
		call		FPD32	; A=LC/(1/W)  X  L  B  C

;  L   ,  C      
		pagesel		$
		btfss		X2, Xstd_C
		goto		L_serial
		;  Rp+Cp -> Rs+Cs
		pagesel		CCopy4_From_A
		movlw		LOW AkkBIm
		call		CCopy4_From_A	; B->AkkBIm
		movlw		LOW C1Im
		call		CCopy4_To_A		;  G
		movlw		LOW AkkBRe
		call		CCopy4_From_A	; G->AkkBRe
		movlw		LOW	E0	;1
		call		Prog_To_A
		movlw		LOW AkkARe
		call		CCopy4_From_A
		call		ClrA
		movlw		LOW AkkAIm
		call		CCopy4_From_A
		call		Div_C	; Z=1/Y

;------  AkkA   .
save_A	
		pagesel		Get_Zsm
		banksel		EEADR
		movlw		HIGH Zstd_begin	; 
		movwf		EEADRH	;   
		banksel		0
		call		Get_Zsm
		call		CPRG_From_A
		
;      Zsm   
		banksel		EEADR
		movlw		HIGH Zsm_begin	;  
		movwf		EEADRH	;   
		banksel		0
		call		Get_Zsm
		call		CPRG_From_A	;  .    
		
;-----   
		pagesel		$
		incf		Freq, F
		movlw		3
		subwf		Freq, W
		btfss		STATUS, Z
		goto		freq_loop
		return

;------    Rs  Xs   
L_serial		
		pagesel		CCopy4_From_A
		movlw		LOW AkkAIm
		call		CCopy4_From_A	; X_L->AkkAIm
		movlw		LOW C1Re
		call		CCopy4_To_A
		movlw		LOW AkkARe
		call		CCopy4_From_A	; Rs->AkkARe
		pagesel		$
		goto		save_A




;===================================================================
; LOAD .
;      
;   100, 1, 10
;  Zsm    
;===================================================================
LOAD_cal_proc
		pagesel		SecLine
		call		SecLine	;   
		movf		m_count, W
		call		NumLCD
		call		DispSP
		call		Freq_disp
		
		movf		m_count, W
		sublw		.9
		btfss		STATUS, Z
		goto		Kn_work
			
;  Zsm
		pagesel		Div_UI
		call		Div_UI

;  Zsm   
		banksel		EEADR
		movlw		HIGH Zsm_begin	;  
		movwf		EEADRH	;   
		banksel		0
		call		Get_Zsm
		call		CPRG_From_A	;  .    

		;    		
		pagesel		$
		movf		Freq, W
		sublw		2		;   - 10
		btfsc		STATUS, Z
		goto		end_LOAD_cal
		incf		Freq, F
		pagesel		Set_Freq
		call		Set_Freq
		goto		Kn_work

end_LOAD_cal
		bcf			Flags2, LOAD_cal_start
		bcf			Flags2, LOAD_cal_mode
		call		set_EE_LOAD ;     
		pagesel		Kn_work
		call		Restore_set	;   ,    
		goto		Kn_work


;===================================================================
;,   LOAD    .
; ,   "!"    
;===================================================================
tst_LOAD
		call		get_EE_LOAD
		
		andwf		Y1	;   = 1 -  
		btfss		STATUS, Z
		return		;  LOAD 
		pagesel		CmdLCD
		movlw		0xC0+.13
		call		CmdLCD
		movlw		"!"
		call		CharLCD
		return

;-----------------------
; W - EE_LOAD
; Y1 -    
get_EE_LOAD
		incf		Range, W	; 0...7 -   +1
		movwf		Y0
		bsf			STATUS, C
		clrf		Y1
rlf_loop
		rlf			Y1, F	;  1
		decfsz		Y0, F	; Range 
		goto		rlf_loop
		
		movlw		LOW EE_LOAD
		movwf		EE_ADR
		pagesel		ReadEEPROM
		call		ReadEEPROM
		banksel		0
		pagesel		$
		return

;===================================================================
;   LOAD    
;  EE_LOAD
;===================================================================
set_EE_LOAD
		call		get_EE_LOAD
		iorwf		Y1, W	;   
save_EE_LOAD
		movwf		EE_DATA
		movlw		LOW EE_LOAD
		movwf		EE_ADR
		pagesel		WriteEEPROM
		call		WriteEEPROM
		banksel		0
		return
		
;===================================================================
;   LOAD    
;  EE_LOAD
;===================================================================
reset_EE_LOAD
		call		get_EE_LOAD
		movwf		Y0	; EE_LOAD
		comf		Y1, W
		andwf		Y0, W
		goto		save_EE_LOAD